/*
 * Linux /proc/interrupts metrics cluster
 *
 * Copyright (c) 2000,2004 Silicon Graphics, Inc.  All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 * 
 * You should have received a copy of the GNU General Public License along
 * with this program; if not, write to the Free Software Foundation, Inc.,
 * 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA
 */

typedef struct {
    int		id;
    char	*name;
    int 	seen;
    int		valid;
    unsigned int count;
} proc_interrupt_counter_t;

typedef struct {
    int		nstats;
    int		maxstats;
    int		ncpus;
    int		maxcpus;
    unsigned int *syscall;
    proc_interrupt_counter_t *stats;
    pmdaIndom	*indom;
} proc_interrupts_t;

extern int refresh_proc_interrupts(proc_interrupts_t *);

